_wMP = WMPEmbed.object;
var playing = true;
var PLAYSTATE_UNDEFINED     = 0;
var PLAYSTATE_STOPPED       = 1; 
var PLAYSTATE_PAUSED        = 2; 
var PLAYSTATE_PLAYING       = 3; 
var PLAYSTATE_SCANFWD       = 4;
var PLAYSTATE_SCANREV       = 5;
var PLAYSTATE_BUFFERING     = 6;  
var PLAYSTATE_WAITING       = 7;
var PLAYSTATE_MEDIAENDED    = 8;
var PLAYSTATE_TRANSITIONING = 9; 
var PLAYSTATE_READY         = 10;
var PLAYSTATE_RECONNECTING  = 11;

var _current_play_state = PLAYSTATE_UNDEFINED;

var _refreshing = false;

var station_selected;
options.defaultValue("URL_0") = "mms://66.90.101.68/rd-bestfm";
options.defaultValue("NAME_0") = "Best FM";
options.defaultValue("last_play") = 1;

var do_action = 1; //1 - Add New, 2 - Edit
var current_play = 0;
var diference=0;
var srollStep=1;

googleTalk.onReceiveTalkData = OnReceiveTalkData;
OnLoad();

function OnLoad(){
	var last_station = options("last_play")
	if(options("URL_0"))
	{
		if(!options("URL_"+last_station))
		{
			var current_station = options("URL_0");
			current_play = 0;
		}else{
			var current_station = options("URL_"+last_station);
			current_play = last_station;
		}
		_wMP.url = current_station;
	}
	SetLabels();
}


function DisplayAddDlg(wh) {
	if(!wh){
		lblTitleAdd.innerText = strAddStation;
		dvAdNew.visible = true;
		do_action = 1;
	}else{
		lblTitleAdd.innerText = strAddStation;
		dvAdNew.visible = true;
		dvListStations.visible = false;
		do_action = 3;
	}
	dvMain.visible=false;
}

function DisplayListDlg() {
	dvListStations.visible = true;
	buildRadioList();
	dvMain.visible=false;
}

function RemoveAllStations(){
	for(i=0;i<StationList.children.count;i++){
		StationList.removeElement(StationList.children(i));
	}
	buildRadioList();
}


function buildRadioList(){

	if(StationList.children.count>0){
		RemoveAllStations();
		return false;
	}
	var radios = load_stations();

	var d=0, z=0;
	if(radios.length>0){
	for (var i = 0; i < radios.length; i++) {
			StationList.appendElement('<div name="StationUnique_'+i+'" tooltip="'+strDblClickPlay+'" ondblclick="doPlayRadioStation(\''+i+'\');" cursor="hand" enabled="true" onclick="sellThis()" onmouseover="overThis()" onmouseout="outThis()" width="230" height="30" x="0" y="'+z*30+'"><label x="5" y="2" width="200" bold="true" height="20" color="#005008" font="Tahoma" size="8" >'+radios[i][1]+'</label><label x="15" y="16" width="200" bold="false" height="13" color="#009011" font="Tahoma" size="8" >'+radios[i][0]+'</label></div>');
			z++;
		
	}
	}else{
		StationList.appendElement('<div width="230" height="30" x="0" y="0"><label x="0" width="200" bold="true" height="30" color="#000000" font="Arial" size="12" y="0" >No Stations Here</label></div>');
	}
	if(i<5)
		sldStations.visible=false;
	else
		sldStations.visible=true;
		
   StationList.height = 30*i;
   srollStep =  (StationList.height - 150) / imgSlider.height;
}


function overThis(){
	if(station_selected != event.srcElement.name) event.srcElement.background = "#8B94AF";
}
function outThis(){
	if(station_selected != event.srcElement.name) event.srcElement.background = "";
}
function sellThis(){
	station_selected = event.srcElement.name;
	for(i=0;i<StationList.children.count;i++){
		if(StationList.children(i).tagName == "div")
			StationList.children(i).background = "";
	}
	event.srcElement.background = "#8B94AF";
}



function DeleteSelectedStation(){
	if (station_selected==null)
		return false;
	var split = station_selected.split("_");
	var stations = load_stations();
	var z=0;
	options.removeAll();
	for (var i=0; i<stations.length; i++ ){
		if(i!=split[1]){
			options("URL_" + z) = stations[i][0];
			options("NAME_" + z) = stations[i][1];
			z++;
		}
	}
	station_selected = null;
	buildRadioList();
}



function EditSelectedStation(){
	if (station_selected==null)
		return false;
	lblTitleAdd.innerText = strEditStation;
	var split = station_selected.split("_");
	dvListStations.visible= false;
	dvAdNew.visible= true;
	
	edtStationName.value = options("NAME_" + split[1]);
	edtStationUrl.value = options("URL_" + split[1]);
	do_action = 2;
}

function doSaveAction(){
	
	
	if(do_action==2){
		if (station_selected==null)
			return false;
		var split = station_selected.split("_");
		var this_id = split[1];	
		if(edtStationUrl.value.match("://")){
			options("URL_" + this_id) = edtStationUrl.value;
			options("NAME_" + this_id) = edtStationName.value;
			}
		dvAdNew.visible = false;
		DisplayListDlg();
		edtStationName.value = "";
		edtStationUrl.value = "";	
	}else if(do_action==3){
		if(edtStationUrl.value.match("://"))
			AddNewStationToList(edtStationName.value,edtStationUrl.value)
		edtStationName.value = "";
		edtStationUrl.value = "";		
		dvAdNew.visible = false;
		DisplayListDlg();
	}else{
		if(edtStationUrl.value.match("://"))
			AddNewStationToList(edtStationName.value,edtStationUrl.value)
		edtStationName.value = "";
		edtStationUrl.value = "";		
		dvAdNew.visible = false;
		dvMain.visible = true;
	}
	
}

function doPlayRadioStation(station){
	if(options("URL_" + station)){
		current_play = station;
		options("last_play") = station
		dvMain.visible = true;
		_wMP.url = options("URL_" + station);
		dvListStations.visible= false;
		station_selected = null;
		_RT_play();
		SetLabels();
	}
}

function AddNewStationToList(name,url){
	var stations = load_stations();
	stations.push([url,name]);
	PutUrls(stations);
}
function CloseRadioList(){
	 dvListStations.visible = false;
	 station_selected=null;
	 SetLabels();
	 dvMain.visible=true;
}
function doCancelAction(){
	if(do_action==2 || do_action==3){
		dvAdNew.visible= false;
		DisplayListDlg();
		edtStationName.value = "";
		edtStationUrl.value = "";	
	}else{
		dvAdNew.visible= false;
		edtStationName.value = "";
		edtStationUrl.value = "";
		dvMain.visible=true;		
	}
	station_selected=null;
}
function StartDrag(){
	diference = event.Y;
	view.onmousemove = "ScrollStations()";
	move=true;
}
function StopDrag(){
	view.onmousemove = "";
	move=false;
}
function ScrollStations(){
	if(event.Y >= (imgSlider.y + dvInnerList.y + diference) && event.Y <= ((imgSlider.y + dvInnerList.y + imgSlider.height)-(sldStations.height-diference))){
		sldStations.y = event.Y - dvInnerList.y - diference;
		StationList.y = 0 - (sldStations.y * srollStep);
	}else if(event.Y < (imgSlider.y + dvInnerList.y + diference)){
		sldStations.y = imgSlider.y;
		StationList.y = 0;
	}else{
		sldStations.y = imgSlider.y + imgSlider.height - sldStations.height;
		StationList.y = 0 - (StationList.height-ListMask.height);
	}
}


/*
	Sharing
*/
function ShareStation(){
	dvShareStation.visible = true;
	BuildFriends();
	dvMain.visible=false;
}
function HideFriends(){
	dvShareStation.visible = false;
	dvMain.visible=true;
}
function RemoveAllFriends(){
	for(i=0;i<FriendList.children.count;i++){
		FriendList.removeElement(FriendList.children(i));
	}
	BuildFriends();
}

function OnReceiveTalkData(friend, data) {
	if(data){
		data = data.split(":@:");
		if (confirm(friend.name + " "+ strAcceptMessage +" \n"+
		data[1]+"\n"+data[0])) {
			view.setTimeout("AddNewStationToList('"+data[1]+"','"+data[0]+"')",5);
		}
	}
}


function BuildFriends(){

	if(FriendList.children.count>0){
		RemoveAllFriends();
		return false;
	}
	var friends = googleTalk.friends.toArray();

	
	var d=0, z=0;
	if(friends.length>0){
	
	for (var i = 0; i < friends.length; i++) {
		if (friends[i].has_sidebar){
			if (friends[i].status == gddFriendStatusOnline) {
				var image = "images/avail.gif";
		    } else if (friends[i].status == gddFriendStatusBusy) {
				var image = "images/busy.gif";
			} else {
				var image = "images/away.gif";
			}
				FriendList.appendElement('<div onclick="sellThisFriend(\''+friends[i].name+'\',\''+friends[i].user_id+'\')" cursor="hand" enabled="true" onmouseover="overThis()" onmouseout="outThis()" width="230" height="30" x="0" y="'+z*30+'"><img src="'+image+'" x="7" y="7" /><label x="23" y="5" width="200" bold="true" height="20" color="#000000" font="Arial" size="12" >'+friends[i].name+'</label></div>');
				z++;
		}
	}
	}else{
		FriendList.appendElement('<div width="230" height="30" x="0" y="0"><label x="0" width="200" bold="true" height="30" color="#000000" font="Arial" size="12" y="0" >No Friends Online</label></div>');
	}
	if(i<5)
		sldFriends.visible=false;
	else
		sldFriends.visible=true;
		
   FriendList.height = 30*i;
   srollStep =  (FriendList.height - 150) / imgSlider.height;
}


function StartDragFriends(){
	diference = event.Y;
	view.onmousemove = "ScrollFriends()";
	move=true;
}
function StopDragFriends(){
	view.onmousemove = "";
	move=false;
}
function ScrollFriends(){
	if(event.Y >= (imgSlider.y + dvFriends.y + diference) && event.Y <= ((imgSlider.y + dvFriends.y + imgSlider.height)-(sldFriends.height-diference))){
		sldFriends.y = event.Y - dvFriends.y - diference;
		FriendList.y = 0 - (sldFriends.y * srollStep);
	}else if(event.Y < (imgSlider.y + dvFriends.y + diference)){
		sldFriends.y = imgSlider.y;
		FriendList.y = 0;
	}else{
		sldFriends.y = imgSlider.y + imgSlider.height - sldFriends.height;
		FriendList.y = 0 - (FriendList.height-FriendMask.height);
	}
}

function sellThisFriend(who,user_id){
		var sData = options("URL_"+current_play)+":@:"+options("NAME_"+current_play);
	 if (confirm(strSendMessage+" "+who+"?\n"+sData)){
	  try {
		friend_user_id = user_id;
		googleTalk.SendTalkData(user_id, sData);
	} catch (e) {
		alert("Error : \nConnection lost");
	}
		HideFriends();
	}
}
/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
function tuneNext(){

	if(options("URL_"+(current_play+1)))
	{
		current_play = Number(current_play+1);
		var current_station = options("URL_"+current_play);
		options("last_play") = current_play
		_wMP.url = current_station;
		_RT_play();
		SetLabels();
	}
}

function tunePrev(){

	if(options("URL_"+(current_play-1)))
	{
		current_play = current_play-1;
		var current_station = options("URL_"+current_play);
		options("last_play") = current_play
		_wMP.url = current_station;
		_RT_play();
		SetLabels();
	}
}
function SetLabels(){
	lblStationUrl.innerText = options("URL_"+current_play);
	lblStationName.innerText = options("NAME_"+current_play);
}
function load_stations() {
  var arr = new Array();
  var url = "";
  var name = "";
  for (var i = 0; url != undefined; ++i) {
    url = options("URL_" + i);
	name = options("NAME_" + i);
    if (url != undefined)
      arr.push([url,name]);
  }
  return arr;
}

function PutUrls(urls) {
  options.removeAll();
  for (var i = 0; i < urls.length; ++i)
  {
    options("URL_" + i) = urls[i][0];
	options("NAME_" + i) = urls[i][1];
	}
}



function _RT_stop()
{
	_wMP.controls.stop();
	playing = false;
	notPlaying();
}

function _RT_play()
{
	_wMP.controls.play();
	playing = true;
	isPlaying();
}

function _RT_volume_up() 
{
  if( _wMP == null ) return;
  _wMP.settings.volume = _wMP.settings.volume + 10;
}

function _RT_volume_down() 
{
  if( _wMP == null ) return;
  _wMP.settings.volume = _wMP.settings.volume - 10;
}
function notPlaying(){
	playing = false;
	btPlay.visible = true;
	btStop.visible = false;
}

function isPlaying() {
	playing = true;
	btPlay.visible = false;
	btStop.visible = true;
}
function _RT_getStation()
{
  if( _wMP == null ) return;
  
  var media = _wMP.currentMedia;

  SetLabels();
  if( media != null )
  {
    lblStation.innerText = media.getItemInfo( "Title" );
  }
  else
  {
    lblStation.innerText = "";
  }
}

function _RT_onplaystatechanged()
{
  var new_playstate = ( _wMP != null ) ? _wMP.playState : PLAYSTATE_STOPPED;
 
  if( _current_play_state != new_playstate )
  {
    _current_play_state = new_playstate;
    
    switch( _current_play_state )
    {
    case PLAYSTATE_STOPPED:
		lblStatus.innerText = "Stoped"
      break;
    case PLAYSTATE_PAUSED:
	  lblStatus.innerText = "Paused"
      break;
      
    case PLAYSTATE_PLAYING:
      lblStatus.innerText = "Playing"
      break;

    case PLAYSTATE_SCANFWD:
    case PLAYSTATE_SCANREV:
	
    case PLAYSTATE_BUFFERING:
		lblStatus.innerText = "Buffering"
      break;
	  
    case PLAYSTATE_WAITING:
		lblStatus.innerText = "Waiting"
      break;
	  
    case PLAYSTATE_MEDIAENDED:
    case PLAYSTATE_TRANSITIONING:
	
    case PLAYSTATE_READY:
	lblStatus.innerText = "Ready"
      break;
	  
    case PLAYSTATE_RECONNECTING:
	lblStatus.innerText = "Reconnect"
      break;

    case PLAYSTATE_UNDEFINED:
      break;
    }
  }
}